---
title: Node.textContent
slug: Web/API/Node/textContent
tags:
  - API
  - DOM
  - Node
  - Property
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>textContent</strong></code> property of the {{domxref ("Node")}} interface represents the text content of the node and its descendants.</p>

<div class="notecard note">
<p><strong>Note:</strong> <code>textContent</code> and {{domxref("HTMLElement.innerText")}} are easily confused, but the two properties are <a href="#Differences_from_innerText">different in important ways</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <var>text</var> = <var>someNode</var>.textContent
<var>someOtherNode</var>.textContent = <var>string</var>
</pre>

<h3 id="Value">Value</h3>

<p>A string or {{jsxref("null")}}</p>

<h2 id="Description">Description</h2>

<p>The value of <code>textContent</code> depends on the situation:</p>

<ul>
	<li>If the node is a {{domxref("document")}} or a {{glossary("Doctype")}}, <code>textContent</code> returns {{jsxref("null")}}.

	<div class="note"><strong>Note:</strong> To get <em>all</em> of the text and <a href="/en-US/docs/Web/API/CDATASection">CDATA data</a> for the whole document, one could use <code><a href="/en-US/docs/Web/API/document/documentElement">document.documentElement</a>.textContent</code>.</div>
	</li>
	<li>If the node is a <a href="/en-US/docs/Web/API/CDATASection">CDATA section</a>, comment, <a href="/en-US/docs/Web/API/ProcessingInstruction">processing instruction</a>, or <a href="/en-US/docs/Web/API/Text">text node</a>, <code>textContent</code> returns the text inside the node, i.e., the {{domxref("Node.nodeValue")}}.</li>
	<li>For other node types, <code>textContent</code> returns the concatenation of the <code>textContent</code> of every child node, excluding comments and processing instructions. (This is an empty string if the node has no children.)</li>
</ul>

<p>Setting <code>textContent</code> on a node removes <em>all</em> of the node's children and replaces them with a single text node with the given string value.</p>

<h3 id="Differences_from_innerText">Differences from innerText</h3>

<p>Don't get confused by the differences between <code>Node.textContent</code> and {{domxref("HTMLElement.innerText")}}. Although the names seem similar, there are important differences:</p>

<ul>
	<li><code>textContent</code> gets the content of <em>all</em> elements, including {{HTMLElement("script")}} and {{HTMLElement("style")}} elements. In contrast, <code>innerText</code> only shows “human-readable” elements.</li>
	<li><code>textContent</code> returns every element in the node. In contrast, <code>innerText</code> is aware of styling and won’t return the text of “hidden” elements.
	<ul>
		<li>Moreover, since <code>innerText</code> takes CSS styles into account, reading the value of <code>innerText</code> triggers a {{glossary("reflow")}} to ensure up-to-date computed styles. (Reflows can be computationally expensive, and thus should be avoided when possible.)</li>
	</ul>
	</li>
	<li>Unlike <code>textContent</code>, altering <code>innerText</code> in Internet Explorer (version 11 and below) removes child nodes from the element and <em>permanently destroys</em> all descendant text nodes. It is impossible to insert the nodes again into any other element or into the same element after doing so.</li>
</ul>

<h3 id="Differences_from_innerHTML">Differences from innerHTML</h3>

<p>{{domxref("Element.innerHTML")}} returns HTML, as its name indicates. Sometimes people use <code>innerHTML</code> to retrieve or write text inside an element, but <code>textContent</code> has better performance because its value is not parsed as HTML.</p>

<p>Moreover, using <code>textContent</code> can prevent {{glossary("Cross-site_scripting", "XSS attacks")}}.</p>

<h2 id="Examples">Examples</h2>

<p>Given this HTML fragment:</p>

<pre class="brush: html notranslate">&lt;div id="divA"&gt;This is &lt;span&gt;some&lt;/span&gt; text!&lt;/div&gt;</pre>

<p>... you can use <code>textContent</code> to get the element's text content:</p>

<pre class="brush: js notranslate">let text = document.getElementById('divA').textContent;
// The text variable is now: 'This is some text!'</pre>

<p>... or set the element's text content:</p>

<pre class="brush: js notranslate">document.getElementById('divA').textContent = 'This text is different!';
// The HTML for divA is now:
// &lt;div id="divA"&gt;This text is different!&lt;/div&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG','#dom-node-textcontent','Node.textContent')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Node.textContent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("HTMLElement.innerText")}}</li>
	<li>{{domxref("Element.innerHTML")}}</li>
	<li><a href="http://perfectionkills.com/the-poor-misunderstood-innerText/">More on differences between <code>innerText</code> and <code>textContent</code></a> (blog post)</li>
</ul>
